# Everything is an object!
print "1.0 is of class ", 1.0.class, "\n"

s = "\"a double-quoted string\""
print s + " is of class ", s.class, "\n"

s = '\'a single-quoted string\''
print s + " is of class ", s.class, "\n"

print "\n"
print (3 == 3), " is of class ", (3 == 3).class, "\n"
print (3 == 2), " is of class ", (3 == 2).class, "\n"
print nil, " is of class ", nil.class, "\n"


print "\n"
def showClassHierarchy(c)
	print "Class hierarchy of ", c, ":\n"
	c = c.class
	while c != nil
		print "\t", c, " has parent class ", c.superclass, "\n"
		c = c.superclass
	end
end

showClassHierarchy(s)
showClassHierarchy(32)


print "\n"
# Everything has methods
x = (-4).abs
y = "cmsc330".length
"cmsc330".methods

# Some methods take code as input (lots more on this later!)
3.times { print "Ra! " }
print "\n"


# Like most scripting languages, Ruby has other primitive types
a = ["this", "is", "an", "array"]
print a, " is of class ", a.class, "\n"

h = { :this   => true,
	  "is"    => 17,
	  "a"     => a,
	  :hash   => 1.25.class,
	  "table" => 17 + 23
}

print h, " is of class ", h.class, "\n"

# Explicit conversions
print x, " is of class ", x.class, "\n"		# from "x = (-4).abs above
x = a.to_s
print x, " is of class ", x.class, "\n"
